//+-----------------------------------------------------------------------------+
//| Copyright (C) 2013 REGEO (http://www.regeo.uji.es/)
//|
//| This program is free software
//| You can redistribute it and/or modify it under the terms of the GNU General Public License,
//| as published by the Free Software Foundation.
//| 
//| This program is distributed in the hope that it will be useful,
//| but WITHOUT ANY WARRANTY; without even the implied warranty of
//| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//+----------------------------------------------------------------------------*/

#ifndef TOOLS_GEOMETRY_VISITED
	#define TOOLS_GEOMETRY_VISITED

	class POINT2D
	{
		public:
			double x, y, merit;

			POINT2D();
			POINT2D(const POINT2D& DP);
			POINT2D(double cx, double cy, double cmerit);
			~POINT2D();
			bool operator==(const POINT2D& right) const;
			bool operator!=(const POINT2D& right) const;
			POINT2D& operator+=(const POINT2D& right);
			POINT2D operator+(const POINT2D& right) const;
			POINT2D& operator-=(const POINT2D& right);
			POINT2D operator-(const POINT2D& right) const;
			POINT2D& operator*=(const POINT2D& right);
			POINT2D operator*(const POINT2D& right) const;
			POINT2D& operator/=(const POINT2D& right);
			POINT2D operator/(const POINT2D& right) const;

			void assign(double x_new, double y_new);

			POINT2D Rotate(POINT2D Center, double Angle);
			POINT2D Rotate(double Angle);
	};


	//public:
		const double Accuracy = 0.0000001;

		const double NUMBER_PI = 3.1415926535897932;
		#define DEGREES_TO_RADIANS(degrees) degrees*NUMBER_PI/180
		#define RADIANS_TO_DEGREES(radians) radians*180/NUMBER_PI

		#define MODULE_2D(A,B) sqrt((A.x-B.x)*(A.x-B.x)+(A.y-B.y)*(A.y-B.y))
		#define MODULE2D(v1x, v1y, v2x, v2y) sqrt(pow(v2x-v1x,2)+pow(v2y-v1y,2))
		#define DOT_PRODUCT_2D(A,B) ( A.x*B.x + A.y*B.y )

		double GetAngle_PI(POINT2D P0, POINT2D P1);

		double GetDistancePointToSegment(POINT2D p0, POINT2D p1, POINT2D V,
										 POINT2D &Intersection);
		double GetDistancePointToSegment(POINT2D p0, POINT2D p1, POINT2D V);

		bool AreCollinear(POINT2D A0, POINT2D A1, 
						  POINT2D B0, POINT2D B1,
						  double ThresholdAngle, double ThresholdDistance);
		bool AreCollinear(double a0x, double a0y,
						  double a1x, double a1y,
						  double b0x, double b0y,
						  double b1x, double b1y,
						  double ThresholdAngle, double ThresholdDistance);
		double GetAngle_PI(POINT2D P1, POINT2D P2, POINT2D P3);


#endif  // TOOLS_GEOMETRY